##Load shared libraries
dyn.load("cRCollapsedGPLM.so")
source("cRCollapsedGPLM.R")

##simulated some data from a latent spatial model
rmvn <- function(n, mu=0, V = matrix(1)){
  p <- length(mu)
  if(any(is.na(match(dim(V),p))))
    stop("Dimension problem!")
  D <- chol(V)
  t(matrix(rnorm(n*p), ncol=p)%*%D + rep(mu,rep(n,p)))
}

set.seed(1)

n <- 100
coords <- cbind(runif(n,0,1), runif(n,0,1))
X <- as.matrix(cbind(1, rnorm(n)))

beta <- as.matrix(c(1,5))
tau.sq <- 0.1
sigma.sq <- 2
phi <- 3/0.5

D <- as.matrix(dist(coords))
R <- exp(-phi*D)
w <- rmvn(1, rep(0,n), sigma.sq*R)
y <- rnorm(n, X%*%beta + w, sqrt(tau.sq))

##call the sampler for beta
n.samples <- 1000


samples <- collasped.gp.lm(y, X, coords, tau.sq, sigma.sq, phi,  n.samples, n.omp.threads=1)

library(coda)
plot(mcmc(t(samples$p.beta.samples)))

## names(samples)

w.hat <- apply(samples$p.w.samples, 1, mean)

plot(w, w.hat)
